| Disk ARchive 2.6.11 Full featured and portable backup and archiving tool

Public Member Functions | Private Member Functions | Private Attributes | List of all members
libdar::archive_options_read Class Reference
API

class holding optional parameters used to read an existing archive More...

`#include <archive_options.hpp>`

Inherited by libdar5::archive_options_read.

## Public Member Functions
| archive_options_read ()
| build an object and set options to their default values
| archive_options_read (const archive_options_read &ref)
| the copy constructor, assignment operator and destructor
| archive_options_read (archive_options_read &&ref) noexcept
archive_options_read & | operator= (const archive_options_read &ref)
archive_options_read & | operator= (archive_options_read &&ref) noexcept
void | clear ()
| reset all the options to their default values
void | set_crypto_algo (crypto_algo val)
| defines the the crypto cypher to use to read the archive (default is crypto_none) More...
void | set_crypto_pass (const secu_string &pass)
| defines the password or passphrase to decrypt (unused if encryption is not set)
void | set_crypto_size (U_32 crypto_size)
| the encryption block size to use to decrypt
void | set_default_crypto_size ()
| set the encryption block size to the default value
void | set_input_pipe (const std::string &input_pipe)
| set the name of the input pipe to read data from (when basename is set to "-") More...
void | set_output_pipe (const std::string &output_pipe)
| set the name of the output pipe to send orders to (when basenale is set to "-") More...
void | set_execute (const std::string &execute)
| set the command to execute before reading each slice (empty string for no script) More...
void | set_info_details (bool info_details)
| defines whether the user needs detailed output of the operation
void | set_lax (bool val)
| defines whether any archive coherence error, system error or media error lead to the abortion of the operation More...
void | set_sequential_read (bool val)
| defines whether to try reading the archive sequentially (ala tar) or using the final catalogue More...
void | set_slice_min_digits (infinint val)
| defines the minimum digit a slice must have concerning its number, zeros will be prepended as much as necessary to respect this
void | set_entrepot (const std::shared_ptr< entrepot > &entr)
| defines the protocol to use to retrieve slices
void | set_ignore_signature_check_failure (bool val)
| whether to warn (true) or ignore (false) signature failure (default is true)
void | set_multi_threaded (bool val)
| whether libdar is allowed to create several thread to work possilbiy faster on multicore CPU (need libthreadar to be effective)
void | set_external_catalogue (const path &ref_chem, const std::string &ref_basename)
| defines whether or not to use the catalogue from an extracted catalogue (instead of the one embedded in the archive) and which one to use
void | unset_external_catalogue ()
| clear any reference to an external catalogue
void | set_ref_crypto_algo (crypto_algo ref_crypto)
| defines the crypto algo for the reference catalogue
void | set_ref_crypto_pass (const secu_string &ref_pass)
| defines the pass for the reference catalogue
void | set_ref_crypto_size (U_32 ref_crypto_size)
| defines the crypto size for the reference catalogue
void | set_ref_execute (const std::string &ref_execute)
| set the command to execute before reading each slice of the reference catalogue More...
void | set_ref_slice_min_digits (infinint val)
| defines the minim digit for slice number of the archive of reference (where the external catalogue is read from)
void | set_ref_entrepot (const std::shared_ptr< entrepot > &entr)
| defines the protocol to use to retrieve slices of the reference archive (where the external catalogue resides)
void | set_header_only (bool val)
| whether we only read the archive header and exit
crypto_algo | get_crypto_algo () const
const secu_string & | get_crypto_pass () const
U_32 | get_crypto_size () const
const std::string & | get_input_pipe () const
const std::string & | get_output_pipe () const
const std::string & | get_execute () const
bool | get_info_details () const
bool | get_lax () const
bool | get_sequential_read () const
infinint | get_slice_min_digits () const
const std::shared_ptr< entrepot > & | get_entrepot () const
bool | get_ignore_signature_check_failure () const
bool | get_multi_threaded () const
bool | is_external_catalogue_set () const
const path & | get_ref_path () const
const std::string & | get_ref_basename () const
crypto_algo | get_ref_crypto_algo () const
const secu_string & | get_ref_crypto_pass () const
U_32 | get_ref_crypto_size () const
const std::string & | get_ref_execute () const
infinint | get_ref_slice_min_digits () const
const std::shared_ptr< entrepot > & | get_ref_entrepot () const
bool | get_header_only () const

## Private Member Functions
void | copy_from (const archive_options_read &ref)
void | move_from (archive_options_read &&ref) noexcept

## Private Attributes
crypto_algo | x_crypto
secu_string | x_pass
U_32 | x_crypto_size
std::string | x_input_pipe
std::string | x_output_pipe
std::string | x_execute
bool | x_info_details
bool | x_lax
bool | x_sequential_read
infinint | x_slice_min_digits
std::shared_ptr< entrepot > | x_entrepot
bool | x_ignore_signature_check_failure
bool | x_multi_threaded
bool | external_cat
path | x_ref_chem
std::string | x_ref_basename
crypto_algo | x_ref_crypto
secu_string | x_ref_pass
U_32 | x_ref_crypto_size
std::string | x_ref_execute
infinint | x_ref_slice_min_digits
std::shared_ptr< entrepot > | x_ref_entrepot
bool | x_header_only

## Detailed Description

class holding optional parameters used to read an existing archive

Definition at line 63 of file archive_options.hpp.

## Member Function Documentation

## ◆ set_crypto_algo()

void libdar::archive_options_read::set_crypto_algo | ( | crypto_algo | val | ) |
| inline

defines the the crypto cypher to use to read the archive (default is crypto_none)

Note
  since release 2.5.0 you may and should provide crypto_none in any case (the default value) for libdar uses the algorithm stored in the archive. However you way override this (in case of corruption for example) by explicitely specifying a crypto algorithm in that case the value of the crypto algorithm stored in the archive is ignored and the algorithm used to decipher is the one specified here.

Definition at line 96 of file archive_options.hpp.

## ◆ set_execute()

void libdar::archive_options_read::set_execute | ( | const std::string & | execute | ) |
| inline

set the command to execute before reading each slice (empty string for no script)

several macros are available:

- %n : the slice number to be read
- %N : the slice number with padded zeros according to slice_min_digits given option
- %b : the archive basename
- %p : the slices path
- %e : the archive extension (usually "dar")
- %c : the archive context ("init", "operation" or "last_slice") see dar(1) man page for more details
- %%% : substitued by %%

Definition at line 130 of file archive_options.hpp.

## ◆ set_input_pipe()

void libdar::archive_options_read::set_input_pipe | ( | const std::string & | input_pipe | ) |
| inline

set the name of the input pipe to read data from (when basename is set to "-")

if input_pipe is set to "" (empty string) the information from dar_slave are expected in standard input else the given string

Definition at line 111 of file archive_options.hpp.

## ◆ set_lax()

void libdar::archive_options_read::set_lax | ( | bool | val | ) |
| inline

defines whether any archive coherence error, system error or media error lead to the abortion of the operation

lax mode is false by default. setting it to true, may allow more data to be restored, but may lead the user to get corrupted data the user will be warned and asked upon what to do if such case arrives.

Definition at line 140 of file archive_options.hpp.

## ◆ set_output_pipe()

void libdar::archive_options_read::set_output_pipe | ( | const std::string & | output_pipe | ) |
| inline

set the name of the output pipe to send orders to (when basenale is set to "-")

if output_pipe is set to "" the orders sent to dar_slave will exit by the standard output else the given string must be the path to a named pipe which will relay the orders to dar_slave

Definition at line 117 of file archive_options.hpp.

## ◆ set_ref_execute()

void libdar::archive_options_read::set_ref_execute | ( | const std::string & | ref_execute | ) |
| inline

set the command to execute before reading each slice of the reference catalogue

several macros are available:

- %n : the slice number to be read
- %N : the slice number with padded zeros according to slice_min_digits given option
- %b : the archive basename
- %p : the slices path
- %e : the archive extension (usually "dar")
- %c : the archive context ("init", "operation" or "last_slice") see dar(1) man page for more details
- %%% : substitued by %%

Definition at line 190 of file archive_options.hpp.

## ◆ set_sequential_read()

void libdar::archive_options_read::set_sequential_read | ( | bool | val | ) |
| inline

defines whether to try reading the archive sequentially (ala tar) or using the final catalogue

the sequential reading must not has been disabled at creation time and the archive must be of minimum format "08" for the operation not to fail

Definition at line 146 of file archive_options.hpp.

The documentation for this class was generated from the following file:

- archive_options.hpp